Unit ADH1R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, AFH1R_p;

procedure ADH1R(var A :Array of Real; var D1 :Real; var D2 :Integer;
                var N :Integer; var IERR :Integer); 
implementation

procedure ADH1R(var A :Array of Real; var D1 :Real; var D2 :Integer;
                var N :Integer; var IERR :Integer);
var
K,I :Integer;
label
_2,_3,_1,_4,_5;
begin
AFH1R(A,N,IERR);
if ( IERR = 65 ) 
 then goto _5;
K := 0;
D1 := 1.0;
D2 := 0;
for I:=1 to N do
 begin
  K := K+I;
  D1 := D1*A[K-1];
_2:
  if ( (Abs(D1)) < 1.e0 ) 
   then goto _3;
  D1 := D1*0.0625;
  D2 := D2+4;
  goto _2;
_3:
  if ( (Abs(D1)) >= 0.0625e0 ) 
   then goto _1;
  D1 := D1*16.0;
  D2 := D2-4;
  goto _3;
_1:
 end;
D1 := D1*D1;
D2 := D2+D2;
_4:
if ( (Abs(D1)) >= 0.0625e0 ) 
 then goto _5;
D1 := D1*16.0;
D2 := D2-4;
goto _4;
_5:
end;

end.
